<?php
if (isset($_REQUEST['sce']) && strtolower($_REQUEST['sce']) == 'view' ) { 
   $filenameReal = __FILE__;			# display source of script if requested so
   $download_size = filesize($filenameReal);
   header('Pragma: public');
   header('Cache-Control: private');
   header('Cache-Control: no-cache, must-revalidate');
   header("Content-type: text/plain");
   header("Accept-Ranges: bytes");
   header("Content-Length: $download_size");
   header('Connection: close');
   readfile($filenameReal);
   exit;
}
$pageName	= 'gaugePage.php';
$pageVersion	= '3.21 2015-10-22';
#-------------------------------------------------------------------------------
# 3.21 2015-10-22 release 2.9 version
#-------------------------------------------------------------------------------
if (!isset($SITE)){echo "<h3>invalid call to script $pageName</h3>";exit;}
$SITE['wsModules'][$pageName] = 'version: ' . $pageVersion;
$pageFile = basename(__FILE__);			// check to see this is the real script
if ($pageFile <> $pageName) {$SITE['wsModules'][$pageFile]	= 'this file loaded instead of '.$pageName;}
ws_message ('<!-- module '.$pageFile.' ==== '.$SITE['wsModules'][$pageFile].' -->');
#
#--------------------------    SETTINGS    -------------------------------------
#
$credits        = true;        # false or true
$gauges_row     = 3;            # 3, 4 or 5 gauges / row. 
$gaugSize       = 221;          # 121 151 and 171 are often used sizes.
$disp_lcd_line  = true;         # true or false if no display of the line with led / forecast /counter
#                               # following lcd settings are ignored if disp_lcd_line is set to false
$disp_lcd_place = 'top';        # 'bottom' = below gauges or 'top' = above gauges.
$disp_lcd_led   = true;         # true or false if no display of the LED
$disp_lcd_fct   = true;         # true or false if no display of the forecast line
$disp_lcd_count = true;         # true or false if no display of the counter.
#
$lcd_fct_width  = 550;          # width of the LCD with forcast text, if displayed
$lcd_height     = 25;           # 
$lcd_line_loc   = 'center';     # 'center'  'left'  'right'
#
# ----------------------------  which gauges should be displayed
$disp_temp      = true;         # true or false if not displayed
$disp_dew       = true;  
$disp_hum       = true;    
$disp_baro      = true;
$disp_windspeed = true;
$disp_direction = true; 
$disp_windchill = true;                 # ?????????????????????????
$disp_rain      = true; 
$disp_rainrate  = true; 
$disp_UV        = true;         # automatically set to false if no sensor is available
$disp_solar     = true;         # automatically set to false if no sensor is available
#
# ----------------------------  minor adaptions for the gauges
$inside_show    = true;         # show button for inside hum and temp if present.
$dew_extra      = true;         # show extra buttons after dew
$dew_chill      = true;         # show button for windchill
$dew_app        = true;         # show button for apparent temp if supported by weatherprogram
$dew_heat       = true;         # show button for heat-index if supported by weatherprogram
$dew_hdx        = true;         # show button for humidex if supported by weatherprogram
#
#-------------------------- END OF   SETTINGS    -------------------------------
echo '<div class="blockDiv"><br />'.PHP_EOL;
include 'gauge_v3.php';
echo '</div>'.PHP_EOL;
# ----------------------  version history
# 3.21 2015-10-22 release 2.9 version
