<?php
if (isset($_REQUEST['sce']) && strtolower($_REQUEST['sce']) == 'view' ) { //--self downloader --
   $filenameReal = __FILE__;	# display source of script if requested so
   $download_size = filesize($filenameReal);
   header('Pragma: public');
   header('Cache-Control: private');
   header('Cache-Control: no-cache, must-revalidate');
   header("Content-type: text/plain");
   header("Accept-Ranges: bytes");
   header("Content-Length: $download_size");
   header('Connection: close');
   readfile($filenameReal);
   exit;
}

$pageName	= 'gauge_v3.php';
$pageVersion	= '3.21 2015-10-23';
#-------------------------------------------------------------------------------
# 3.21 2015-10-23 release 2.9 version
#-------------------------------------------------------------------------------
if (!isset($SITE)){echo "<h3>invalid call to script $pageName</h3>";exit;}
$SITE['wsModules'][$pageName] = 'version: ' . $pageVersion;
$pageFile = basename(__FILE__);			// check to see this is the real script
if ($pageFile <> $pageName) {$SITE['wsModules'][$pageFile]	= 'this file loaded instead of '.$pageName;}
ws_message ('<!-- module '.$pageFile.' ==== '.$SITE['wsModules'][$pageFile].' -->');
#-------------------------------------------------------------------------------
#  NO SETTINGS below this point
#-------------------------------------------------------------------------------
$scriptVersion  = '3.21';
# ----------------------------  text used for the radio buttons
$in_text        = langtransstr('Inside');
$out_text       = langtransstr('Outside');
$dew_text       = langtransstr('Dewpoint');
$app_text       = langtransstr('Apparent');
$chill_text     = langtransstr('Wind Chill');
$heat_text      = langtransstr('Heat Index');
$hdx_text       = langtransstr('Humidex');
#
if (!isset ($gauge_in_frame) ) {
        $my_gauge_folder= './gauges/';
        $my_realtime    = './';
}
else  { $my_gauge_folder= './';
        $my_realtime    = '../';
} 
#
if (!isset ($SITE['UV'])         || $SITE['UV']         == false) { $disp_UV     = false;}   # check if sensors for gauges arew available so  gauges can be displayed
if (!isset ($SITE['SOLAR'])      || $SITE['SOLAR']      == false) { $disp_solar  = false;}
if (!isset ($SITE['tempInside']) || $SITE['tempInside'] == false) { $inside_show = false;}
#
if (isset ($disp_lcd_line) && $disp_lcd_line == true) { 
        if (!isset ($disp_lcd_led) )    { $disp_lcd_led = true;} 
        elseif ($disp_lcd_led <> true)  { $disp_lcd_led = false;}  
        if (!isset ($disp_lcd_fct) )    { $disp_lcd_fct = true;} 
        elseif ($disp_lcd_fct <> true)  { $disp_lcd_fct = false;}  
        if (!isset ($disp_lcd_count) )  { $disp_lcd_count = true;} 
        elseif ($disp_lcd_count <> true){ $disp_lcd_count = false;} 
        if (!isset ($lcd_line_loc) )    { $lcd_line_loc = 'center';}
        elseif ($lcd_line_loc <> 'left' && $lcd_line_loc <> 'right')   
                                        { $lcd_line_loc = 'center';}
}
else {  $disp_lcd_line  = $disp_lcd_led = $disp_lcd_fct = $disp_lcd_count = false;
        $lcd_fct_width  = 0;
}
if (!isset ($gaugSize) )                { $gaugSize     = 171;}
if (!isset ($SITE['steelTime']) )       { $steelTime    = 30;}
elseif ($SITE['steelTime'] > 60)        { $steelTime    = 60;}
elseif ($SITE['steelTime'] < 10)        { $steelTime    = 10;} 
else                                    { $steelTime    = $SITE['steelTime'];}
#
$rwow_end       = '</tr>'.PHP_EOL;
$rwow_start     = '<tr>'.PHP_EOL;
$table_start    = '<table class="gaugeTable">'.PHP_EOL;  # margin: 5px auto;
$table_end      = '</table>'.PHP_EOL;
$div_style      = 'style="";'; #'style="margin: 10px 0 0 10px;"';
#
$credit_txt = '';
if (isset($credits) && $credits == true) {
        $credit_txt    = '<hr />
<p style="width: 98%; margin: 5px auto; text-align: center;"><small>
  Scripts by <a href="http://wiki.sandaysoft.com/a/SteelSeries_Gauges">Mark Crossley</a> - 
  adapted for <a href="http://leuven-template.eu">Leuven-Template</a> (v'.$scriptVersion.') -
  Gauges programmed by Gerrit Grunwald <a href="http://harmoniccode.blogspot.com" target="_blank">SteelSeries</a>.</small>
</p>'.PHP_EOL;
}
# 
$cnt_gauges     = 0;
$temp_txt       = '';
if (!isset ($disp_temp) || $disp_temp <> true) {$disp_temp = false;}
if ($disp_temp) {
        $cnt_gauges++;
        $temp_txt       .= '<td><div id="tip_0" '.$div_style.'><canvas id="canvas_temp" ></canvas></div>'.PHP_EOL;
        if ($inside_show) { 
            $temp_txt   .= '  <input id="rad_temp1" type="radio" name="rad_temp" value="out" checked onclick="doTemp(this);">'.PHP_EOL;
            $temp_txt   .= '&nbsp<label id="lab_temp1" for="rad_temp1">'.$out_text.'</label>'.PHP_EOL;
            $temp_txt   .= '  <input id="rad_temp2" type="radio" name="rad_temp" value="in" onclick="doTemp(this);">'.PHP_EOL;
            $temp_txt   .= '&nbsp<label id="lab_temp2" for="rad_temp2">'.$in_text.'</label>'.PHP_EOL;
        }
        $temp_txt       .= '</td>'.PHP_EOL;
}
$dew_txt        = '';
if (!isset ($disp_dew)  || $disp_dew  <> true) {$disp_dew = false;}
if ($disp_dew) {
        $cnt_gauges++;
        $dew_txt        .= '<td><div id="tip_1" '.$div_style.'><canvas id="canvas_dew" ></canvas></div>'.PHP_EOL;        
        if (!isset ($dew_extra) || $dew_extra <> true || $disp_dew == false) {$dew_extra = false;}
        if ($dew_extra) {
                $dew_txt        .= '  <input id="rad_dew1" type="radio" name="rad_dew" value="dew" checked onclick="doDew(this);">'.PHP_EOL;
                $dew_txt        .= '&nbsp<label id="lab_dew1" for="rad_dew1">'.$dew_text.'</label>'.PHP_EOL;
 #
                if ($SITE['WXsoftware'] <> 'CU' && $SITE['WXsoftware'] <> 'WC') { $dew_app        = false;}
                if ($SITE['WXsoftware'] == 'WL' || $SITE['WXsoftware'] == 'WS') { $dew_hdx        = false;}
                $cnt_buttons_tot        = 1; 
                if ($dew_app)   {$cnt_buttons_tot++;}
                if ($dew_chill) {$cnt_buttons_tot++;}
                if ($dew_heat)  {$cnt_buttons_tot++;}
                if ($dew_hdx)   {$cnt_buttons_tot++;}
                if ($cnt_buttons_tot == 5)      {$break = 3;}
                elseif ($cnt_buttons_tot == 4)  {$break = 2;}
                else                            {$break = 9;}
                $cnt_buttons_tot        = 1;
#
                if ($dew_app){  
                        $dew_txt        .= '  <input id="rad_dew2" type="radio" name="rad_dew" value="app"  onclick="doDew(this);">'.PHP_EOL;
                        $dew_txt        .= '&nbsp<label id="lab_dew2" for="rad_dew2">'.$app_text.'</label>'.PHP_EOL;
                        $cnt_buttons_tot++;
                        if ($cnt_buttons_tot == $break) {
                                $dew_txt        .= '  <br>'.PHP_EOL;
                        }
                }
                if ($dew_chill) {
                        $dew_txt        .= '  <input id="rad_dew3" type="radio" name="rad_dew" value="wnd" onclick="doDew(this);">'.PHP_EOL;
                        $dew_txt        .= '&nbsp<label id="lab_dew3" for="rad_dew3">'.$chill_text.'</label>'.PHP_EOL;
                        $cnt_buttons_tot++;
                        if ($cnt_buttons_tot == $break) {
                                $dew_txt        .= '  <br>'.PHP_EOL;
                        }
                }
                if ($dew_heat ) {
                        
                        $dew_txt        .= '  <input id="rad_dew4" type="radio" name="rad_dew" value="hea" onclick="doDew(this);">'.PHP_EOL;
                        $dew_txt        .= '&nbsp<label id="lab_dew4" for="rad_dew4">'.$heat_text.'</label>'.PHP_EOL;
                        $cnt_buttons_tot++;
                        if ($cnt_buttons_tot == $break) {
                                $dew_txt        .= '  <br>'.PHP_EOL;
                        }
                }
                if ($dew_hdx ) { 		 
                        $dew_txt        .= '  <input id="rad_dew5" type="radio" name="rad_dew" value="hum" onclick="doDew(this);">'.PHP_EOL;
                        $dew_txt        .= '&nbsp<label id="lab_dew5" for="rad_dew5">'.$hdx_text.'</label>'.PHP_EOL;
                } 
        }
        $dew_txt        .= '</td>'.PHP_EOL;
}
$hum_txt        = '';
if (!isset ($disp_hum)  || $disp_hum  <> true) {$disp_hum = false;}
if ($disp_hum) {
        $cnt_gauges++;
        $hum_txt        .= '<td><div id="tip_4" '.$div_style.'><canvas id="canvas_hum" ></canvas></div>'.PHP_EOL;
        if ($inside_show) { 
	    $hum_txt    .= '  <input id="rad_hum1" type="radio" name="rad_hum" value="out" checked onclick="doHum(this);">'.PHP_EOL;
	    $hum_txt    .= '  <label id="lab_hum1" for="rad_hum1">'.$out_text.'</label>'.PHP_EOL;
	    $hum_txt    .= '  <input id="rad_hum2" type="radio" name="rad_hum" value="in" onclick="doHum(this);">'.PHP_EOL;
	    $hum_txt    .= '  <label id="lab_hum2" for="rad_hum2">'.$in_text.'</label>'.PHP_EOL;
        }
        $hum_txt        .= '</td>'.PHP_EOL; 
}
$baro_text      = '';
if (!isset ($disp_baro)  || $disp_baro  <> true) {$disp_baro = false;}
if ($disp_baro) {
        $cnt_gauges++;
        $baro_text      .='<td><div id="tip_5" '.$div_style.'><canvas id="canvas_baro" ></canvas></div></td>'.PHP_EOL; 
}
$speed_text      = '';
if (!isset ($disp_windspeed)  || $disp_windspeed  <> true) {$disp_windspeed = false;}
if ($disp_windspeed) {
        $cnt_gauges++;
        $speed_text     .='<td><div id="tip_6" '.$div_style.'><canvas id="canvas_wind" ></canvas></div></td>'.PHP_EOL; 
}
$dir_text      = '';
if (!isset ($disp_direction)  || $disp_direction  <> true) {$disp_direction = false;}
if ($disp_direction) {
        $cnt_gauges++;        
        $dir_text       .='<td><div id="tip_7" '.$div_style.'><canvas id="canvas_dir" ></canvas></div></td>'.PHP_EOL; 
}
$rain_text      = '';
if (!isset ($disp_rain)  || $disp_rain  <> true) {$disp_rain = false;}
if ($disp_rain) {
        $cnt_gauges++;
        $rain_text      .='<td><div id="tip_2" '.$div_style.'><canvas id="canvas_rain" ></canvas></div></td>'.PHP_EOL; 
}
$rate_text      = '';
if (!isset ($disp_rainrate)  || $disp_rainrate  <> true) {$disp_rainrate = false;}
if ($disp_rainrate) {
        $cnt_gauges++;
        $rate_text      .='<td><div id="tip_3" '.$div_style.'><canvas id="canvas_rrate" ></canvas></div></td>'.PHP_EOL; 
}
$UV_text      = '';
if (!isset ($disp_UV)  || $disp_UV  <> true) {$disp_UV = false;}
if ($disp_UV) {
        $cnt_gauges++;
        $UV_text        .='<td id="uv_cell"><div id="tip_8" '.$div_style.'><canvas id="canvas_uv" ></canvas></div></td>'.PHP_EOL; 
}
$solar_text     = '';
if (!isset ($disp_solar)  || $disp_solar  <> true) {$disp_solar = false;}
if ($disp_solar) {
        $cnt_gauges++;
        $solar_text     .='<td id="solar_cell" ><div id="tip_9" '.$div_style.'><canvas id="canvas_solar" ></canvas></div></td>'.PHP_EOL; 
}
$clock_text     = '';
if (!isset ($disp_clock)  || $disp_clock  <> true) {$disp_clock = false;}
if ($disp_clock) {
        $cnt_gauges++;
        $clock_text     .='<td id="clock_cell" ><div id="" '.$div_style.'><canvas id="canvas_clock" ></canvas></div></td>'.PHP_EOL; 
}
ws_message ('<!-- $cnt_gauges = '.$cnt_gauges. ' - $gauges_row = '.$gauges_row.' -->');
if ($cnt_gauges == 0) {
        ws_message ('<!-- $cnt_gauges = '.$cnt_gauges. ' - No gauges to display, script end -->');
        return;
}
#
# calculate # gauges / row  max number of rows 3, no orpahns
$rows   = array();
if (!isset ($gauges_row) ||  $gauges_row < 3 || $gauges_row > 6) {$gauges_row = 4;}
if ($cnt_gauges == 10) {
        if      ($gauges_row == 5)      { $rows[1] = 5; $rows[2] = 5; }
        else                            { $rows[1] = 4; $rows[2] = 4; $rows[3] = 2; $gauges_row = 4; }
}
elseif ($cnt_gauges == 9) {
        if      ($gauges_row == 5)      { $rows[1] = 5; $rows[2] = 4; }
        else                            { $rows[1] = 3; $rows[2] = 3; $rows[3] = 3; $gauges_row = 3;}
}
elseif ($cnt_gauges == 8 ) {
        if   ($gauges_row > 3)          { $rows[1] = 4; $rows[2] = 4;  $gauges_row = 4; }
        else                            { $rows[1] = 3; $rows[2] = 3; $rows[3] = 2;   $gauges_row = 3;}
}
elseif ($cnt_gauges == 7) {
        if   ($gauges_row > 3)          { $rows[1] = 4; $rows[2] = 3; $gauges_row = 4; }
        else                            { $rows[1] = 3; $rows[2] = 2; $rows[3] = 2; $gauges_row = 3;}
}
elseif ($cnt_gauges == 6  ) { 
        if ($gauges_row == 6)           { $rows[1] = 6; }
        else                            { $rows[1] = 3; $rows[2] = 3; $gauges_row = 3;}
}
#
elseif ($cnt_gauges == 5 ) {
        if      ($gauges_row > 4)       { $rows[1] = 5;}
        else                            { $rows[1] = 3; $rows[2] = 2; $gauges_row = 3;}
}
else {  $rows[1] = $cnt_gauges; $gauges_row = $cnt_gauges;
}
#
$lcd_txt = '';
if ($disp_lcd_line) {
        $lcd_txt .= '<p style="width: 98%; margin: 5px auto; text-align: '.$lcd_line_loc.';">'.PHP_EOL;
        if ($disp_lcd_led) {
                $lcd_txt .= '  <a href="javascript: window.location.reload()" ><canvas id="canvas_led"></canvas></a>&nbsp;&nbsp;&nbsp;';
        }
        if ($disp_lcd_fct) {
                $lcd_txt .= '  <canvas id="canvas_status" ></canvas>&nbsp;&nbsp;';
        }
        if ($disp_lcd_count) {        
                $lcd_txt .= '  <canvas id="canvas_timer" ></canvas>';
        }
        $lcd_txt .= '</p>'.PHP_EOL;
}
#
ws_message ('<!-- Now set to '.print_r($rows,true).' -->');
if ($disp_lcd_place == 'top') { echo $lcd_txt; $lcd_txt = '';}
echo $table_start;
$last_row       = $gauges_row;
foreach ($rows as $key => $gauges_this_row) {
ws_message ('<!-- row = '.$key.' $gauges_this_row = '.$gauges_this_row.' -->');
        if ($last_row  <> $gauges_this_row) {echo  $table_end.$table_start; }
        echo $rwow_start;
        $cnt_printed    = 0;
        if ($temp_txt <> '') {
                $cnt_printed++;
                echo $temp_txt;
                $temp_txt       = '';
                if ($cnt_printed == $gauges_this_row) {echo '</tr>'.PHP_EOL; continue;}        
        }
        if ($dew_txt <> '') {
                $cnt_printed++;
                echo $dew_txt;
                $dew_txt        = '';
                if ($cnt_printed == $gauges_this_row) {echo '</tr>'.PHP_EOL; continue;}        
        }
        if ($hum_txt <> '') {
                $cnt_printed++;
                echo $hum_txt;
                $hum_txt        = '';
                if ($cnt_printed == $gauges_this_row) {echo '</tr>'.PHP_EOL; continue;}        
        }
        if ($baro_text <> '') {
                $cnt_printed++;
                echo $baro_text;
                $baro_text        = '';
                if ($cnt_printed == $gauges_this_row) {echo '</tr>'.PHP_EOL; continue;}        
        }
        if ($speed_text <> '') {
                $cnt_printed++;
                echo $speed_text;
                $speed_text        = '';
                if ($cnt_printed == $gauges_this_row) {echo '</tr>'.PHP_EOL; continue;}        
        }
        if ($dir_text <> '') {
                $cnt_printed++;
                echo $dir_text;
                $dir_text        = '';
                if ($cnt_printed == $gauges_this_row) {echo '</tr>'.PHP_EOL; continue;}        
        }
        if ($rain_text <> '') {
                $cnt_printed++;
                echo $rain_text;
                $rain_text        = '';
                if ($cnt_printed == $gauges_this_row) {echo '</tr>'.PHP_EOL; continue;}        
        }
        if ($rate_text <> '') {
                $cnt_printed++;
                echo $rate_text;
                $rate_text        = '';
                if ($cnt_printed == $gauges_this_row) {echo '</tr>'.PHP_EOL; continue;}        
        }
        if ($UV_text <> '') {
                $cnt_printed++;
                echo $UV_text;
                $UV_text        = '';
                if ($cnt_printed == $gauges_this_row) {echo '</tr>'.PHP_EOL; continue;}        
        }
        if ($solar_text <> '') {
                $cnt_printed++;
                echo $solar_text;
                $solar_text        = '';
                if ($cnt_printed == $gauges_this_row) {echo '</tr>'.PHP_EOL; continue;}        
        }
        if ($disp_clock) {
                $cnt_printed++;
                echo $clock_text;
                $clock_text        = '';
                if ($cnt_printed == $gauges_this_row) {echo '</tr>'.PHP_EOL; continue;}        
        }
        
}

echo  $table_end;
echo $lcd_txt.$credit_txt.
'<script src="http://ajax.googleapis.com/ajax/libs/jquery/1.7.0/jquery.min.js"></script>
<script src="'.$my_gauge_folder.'scripts/tween-min.js"></script>
<script src="'.$my_gauge_folder.'scripts/language.js"></script>'.PHP_EOL;
#
echo '<script>'.PHP_EOL;
echo '  var g_size                      = '.$gaugSize.';'.PHP_EOL;
echo '  var g_count                     = '.$steelTime.';'.PHP_EOL;
echo '  var wxLang                      = "'.$lang.'";'.PHP_EOL;  
echo '  var LANG                        = LANG_'.strtoupper($lang).';'.PHP_EOL;
echo '  var g_forecast_width            = '.$lcd_fct_width.';'.PHP_EOL;
echo '  var g_forecast_height           = '.$lcd_height.';'.PHP_EOL;
$string = trim(str_replace('&deg;','',$SITE['uomTemp']));
echo '  var g_tempunit                  = "'.$string.'";'.PHP_EOL;
echo '  var g_rainunit                  = "'.trim($SITE['uomRain']).'";'.PHP_EOL;
echo '  var g_pressunit                 = "'.trim($SITE['uomBaro']).'";'.PHP_EOL;
echo '  var g_windunit                  = "'.trim($SITE['uomWind']).'";'.PHP_EOL;
list ($hrs,$mins) =  explode (':', date('P') );
if ($disp_clock) {
        echo '  var g_timeZoneOffsetHour        = '.$hrs.';'.PHP_EOL;
        echo '  var g_timeZoneOffsetMinute      = '.$mins.';'.PHP_EOL;
}
#
if ($disp_UV) {
	echo '  var g_showUvGauge               = true;'.PHP_EOL;
}
else {  echo '  var g_showUvGauge               = false;'.PHP_EOL;
}
if ($disp_solar) {
	echo '  var g_showSolarGauge            = true;'.PHP_EOL;
} 
else {  echo '  var g_showSolarGauge            = false;'.PHP_EOL;
}	  
#	ws_popupGraphs	0 = no graphs 1 = Cumulus, 2 = wxGraphs (WD or MH)   3 = weatherlink
#	g_realTimeURL	name of the file or script which supplies the realtime values
#	g_imgPathURL	relative path for the graph images

echo '  var g_realTimeURL               = "'.$my_realtime.'ws_realtime.php";'.PHP_EOL; #"'.$my_realtime.'ws_realtime.php";'.PHP_EOL;   # "'.$my_gauge_folder.'new.txt";'.PHP_EOL;  
if (!isset ($show_graphs) || $show_graphs <> 'false' ) {$show_graphs = 'true';}
echo '  var g_showPopupDataGraphs       = '.$show_graphs.';'.PHP_EOL; 
 
switch ($SITE['WXsoftware']) {
  case  'CU':
        echo '  var ws_popupGraphs              = 1; '.PHP_EOL;
        echo '  var g_imgPathURL                = "'.$SITE['graphImageDir'].'"; '.PHP_EOL;
  break;  
  case  'WD':
        echo '  var ws_popupGraphs              = 2; '.PHP_EOL;
        echo '  var g_imgPathURL                = "wxgraphs/";'.PHP_EOL;
  break;
  case  'CW':
        echo '  var ws_popupGraphs              = 2; '.PHP_EOL;
        echo '  var g_imgPathURL                = "wxgraphs/";'.PHP_EOL;
  break;
  case  'WL':
        echo '  var ws_popupGraphs              = 3;'.PHP_EOL; 
        echo '  var g_imgPathURL                = "'.$SITE['graphImageDir'].'"; '.PHP_EOL; 
  break;
  case'MH':  
        echo '  var ws_popupGraphs              = 2; '.PHP_EOL; 
        echo '  var g_imgPathURL                = "wxgraphs/";'.PHP_EOL;
  break;
  case 'WC': 
        echo '  var ws_popupGraphs              = 4; '.PHP_EOL; 
        echo '  var g_imgPathURL                = "'.$SITE['graphImageDir'].'"; '.PHP_EOL; 
  break;  
  case 'VW': 
        echo '  var ws_popupGraphs              = 5; '.PHP_EOL; 
        echo '  var g_imgPathURL                = "'.$SITE['graphImageDir'].'"; '.PHP_EOL; 
  break;	
  case 'WV': 
        echo '  var ws_popupGraphs              = 6; '.PHP_EOL; 
        echo '  var g_imgPathURL                = "'.$SITE['graphImageDir'].'"; '.PHP_EOL; 
  break;
  case  'WS':
        echo '  var ws_popupGraphs              = 2; '.PHP_EOL;
        echo '  var g_imgPathURL                = "wxgraphs/";'.PHP_EOL;
  break;	
  default:
        echo '  var ws_popupGraphs              = 0; '.PHP_EOL;
        echo '  var g_imgPathURL                = "'.$SITE['graphImageDir'].'"; '.PHP_EOL; 
        echo '  var g_showPopupDataGraphs       = false;'.PHP_EOL;  
}

echo '</script>
<script src="'.$my_gauge_folder.'scripts/steelseries-min.js"></script>
<script src="'.$my_gauge_folder.'scripts/wsGauges_v3.js"></script>
';
# ----------------------  version history
# 3.21 2015-10-23 release 2.9 version
