<?php
#-------------------- S e t t i n g s ----------------------------------
#
$credits        = false;        # false or true
$gauges_row     = 6;            # 3, 4 or 5 gauges / row.  Or 6 gauges in 1 row.
$gaugSize       = 121;          # 121 151 and 171 are often used sizes.
$disp_lcd_line  = true;         # true or false if no display of the line with led / forecast /counter
#                               # following lcd settings are ignored if disp_lcd_line is set to false
$disp_lcd_place = 'bottom';     # 'bottom' = below gauges or 'top' = above gauges.
$disp_lcd_led   = true;         # true or false if no display of the LED
$disp_lcd_fct   = true;         # true or false if no display of the forecast line
$disp_lcd_count = true;         # true or false if no display of the counter.
#
$lcd_fct_width  = 500;          # width of the LCD with forcast text, if displayed
$lcd_height     = 15;           # 
$lcd_line_loc   = 'center';     # 'center'  'left'  'right'
#
#
# ----------------------------  which gauges should be displayed
$disp_temp      = true;         # true or false if not displayed
$disp_dew       = false;  
$disp_hum       = true;    
$disp_baro      = true;
$disp_windspeed = true;
$disp_direction = true; 
$disp_rain      = false; 
$disp_rainrate  = false; 
$disp_UV        = false;        # automatically set to false if no sensor is available
$disp_solar     = false;        # automatically set to false if no sensor is available
#
$disp_clock     = true;         # only for display in iframe
#
# ----------------------------  minor adaptions for the gauges
$inside_show    = false;        # show button for inside hum and temp if present.
$dew_extra      = false;        # show extra buttons after dew
$dew_chill      = true;         # show button for windchill
$dew_app        = true;         # show button for apparent temp if supported by weatherprogram
$dew_heat       = true;         # show button for heat-index if supported by weatherprogram
$dew_hdx        = true;         # show button for humidex if supported by weatherprogram
#
#
#--end of settings.  do not change anything below this point  ----------
#
#-----------------------------------------------------------------------
# display source of script if requested so
#-----------------------------------------------------------------------
if (isset($_REQUEST['sce']) && strtolower($_REQUEST['sce']) == 'view' ) {
   $filenameReal = __FILE__;
   $download_size = filesize($filenameReal);
   header('Pragma: public');
   header('Cache-Control: private');
   header('Cache-Control: no-cache, must-revalidate');
   header("Content-type: text/plain");
   header("Accept-Ranges: bytes");
   header("Content-Length: $download_size");
   header('Connection: close');
   readfile($filenameReal);
   exit;
}
$pageName	= 'gaugeFrame.php';
$pageVersion	= '3.21 2015-10-23';
#-------------------------------------------------------------------------------
# 3.21 2015-10-23 release 2.9 version
#-------------------------------------------------------------------------------
if (isset($_REQUEST['debug']) ) {
 	ini_set('display_errors', 'On'); 
	error_reporting(E_ALL);	
}
if (isset($_REQUEST['lang']) ) {
        $lang   = trim($_REQUEST['lang']);
 	$lang   = substr($lang.'en',0,2);
}
$SITE= array();
include '../wsLoadSettings.php';
include '../wsLangFunctions.php';
$gauge_in_frame = true;         # DO NOT CHANGE
#
$show_graphs    = 'false';      # DO NOT CHANGE
#
?>
<!DOCTYPE html>
<html lang="<?php echo $lang; ?>" style="overflow-y: hidden;">
<head>
	<meta charset="<?php echo $SITE['charset']; ?>" />
	<meta name="description" content="home - your organization" />
	<meta http-equiv="Content-Type" content="text/html; charset=<?php echo $SITE['charset']; ?>"/>
	<link rel="stylesheet" href="./css/gauges-ss.css" />
	<title>home - your organization</title>
</head>
<body style="margin: 0 8px;">
<?php  
echo $pathString; 
include 'gauge_v3.php';
?>
</body>
</html>